import { PatchSchema, NodeMapSchema, NodeSchema } from "../export.js";
import Project from "../project.js";
interface SignalSequenceMap {
    [nodeId: number]: {
        [portKey: string]: NodeSchema[];
    };
}
interface SignalSource {
    node: NodeSchema;
    portKey: string;
}
declare type ResultSequences = {
    startNodes: NodeSchema[];
    mainSequence: NodeSchema[];
    signalSequences: SignalSequenceMap;
};
declare class Sequencer {
    project: Project;
    patch: PatchSchema;
    pathTrackingMap: {
        [nodeId: number]: {
            counter: number;
            depth: number;
            signalSource: SignalSource | null;
        };
    };
    constructor(project: Project, patch: PatchSchema);
    getInputCount(node: NodeSchema): number;
    getStartNodes(nodes: NodeMapSchema): NodeSchema[];
    track(): ResultSequences;
}
export default Sequencer;
