export const FLOW_PORT_KEY = "_flow_port_";
class Component {
    constructor(namespace, key, data) {
        this.namespace = namespace;
        this.key = key;
        this.data = data;
    }
    getFullKey() {
        return this.namespace.key + "." + this.key;
    }
    hasProperty(key) {
        if (this.data.properties != null) {
            return key in this.data.properties;
        }
        return false;
    }
    hasInputPort(key) {
        return key == FLOW_PORT_KEY || (this.data.inputs != null && key in this.data.inputs);
    }
    hasOutputPort(key) {
        return key == FLOW_PORT_KEY || this.data.outputs != null && key in this.data.outputs;
    }
    getInputPort(key) {
        return this.data.inputs != null ? this.data.inputs[key] : null;
    }
    getOutputPort(key) {
        return this.data.outputs != null ? this.data.outputs[key] : null;
    }
    getName() {
        return this.namespace.data.name + "." + this.data.name;
    }
    getInputs() {
        let inputs = this.data.inputs;
        return inputs ? inputs : {};
    }
    getOutputs() {
        let outputs = this.data.outputs;
        return outputs ? outputs : {};
    }
}
export default Component;
//# sourceMappingURL=component.js.map