import { registerNamespace } from "./../component_manager.js";
let ns_core_memory_object = registerNamespace("core.object", {
    name: "Object",
    defaultIcon: "data_object",
    description: ``,
});
ns_core_memory_object.registerComponent("object", {
    name: "Object",
    outputs: {
        "object": {
            name: "Object",
            type: "core.object.object"
        }
    },
    evaluator: `@{out:object}={};`
});
ns_core_memory_object.registerComponent("get", {
    name: "Get",
    inputs: {
        "object": {
            name: "Object",
            type: "core.object.object",
        },
        "key": {
            name: "Key",
            type: "string",
        },
    },
    outputs: {
        "value": {
            name: "Value",
            type: "any"
        }
    },
    evaluator: `@{out:value}=@{in:object}[@{in:key}];`
});
ns_core_memory_object.registerComponent("set", {
    name: "Set",
    inputs: {
        "object": {
            name: "Object",
            type: "core.object.object",
        },
        "key": {
            name: "Key",
            type: "string",
        },
        "value": {
            name: "Value",
            type: "any",
        },
    },
    outputs: {
        "object": {
            name: "Object",
            type: "core.object.object"
        }
    },
    evaluator: `@{in:object}[@{in:key}]=@{in:value};@{out:object}=@{in:object};`
});
//# sourceMappingURL=core_object.js.map