import { registerType } from "../type_manager.js";
import { registerNamespace } from "./../component_manager.js";
registerType("string", {
    name: "String",
    defaultComponent: "core.string.constant"
});
let namespace = registerNamespace("core.string", {
    name: "Core.String",
    defaultIcon: "title",
    description: ``
});
namespace.registerComponent("constant", {
    name: "String",
    description: "",
    outputs: {
        "value": {
            name: "Value",
            type: "string",
        }
    },
    properties: {
        "value": {
            name: "Value",
            type: "string",
            defaultValue: "",
        }
    },
    evaluator: `@{out:value}=@{prop:value}`
});
namespace.registerComponent("concat", {
    name: "Concat",
    description: "",
    inputs: {
        "string": {
            name: "String",
            type: "string",
            isMulti: true,
        }
    },
    outputs: {
        "result": {
            name: "Result",
            type: "string"
        }
    },
    properties: {
        separator: {
            name: "Separator",
            type: "string",
            defaultValue: "",
        }
    },
    evaluator: `console.log("concat", @{join:string:+});@{out:result}=@{join:string:+}`
});
//# sourceMappingURL=core_string.js.map