//type CallbackFn = <T> (arg: T | null) => void;
class EventHandler {
    constructor() {
        this.listenersMap = {};
    }
    addEventListener(eventName, callback) {
        if (this.listenersMap[eventName] == null) {
            this.listenersMap[eventName] = [];
        }
        let idx = this.listenersMap[eventName].length;
        this.listenersMap[eventName].push(callback);
        return idx;
    }
    triggerEvent(eventName, arg = null) {
        let listeners = this.listenersMap[eventName];
        if (listeners == null) {
            return;
        }
        for (let listener of listeners) {
            listener(arg);
        }
    }
}
export default EventHandler;
//# sourceMappingURL=event_handler.js.map