import { Events } from "./events";
import observer from "./observer";
class Group {
    constructor(id, name, comment = "", nodeIdList = []) {
        this.name = "New Group";
        this.comment = "";
        this.id = id;
        this.name = name;
        this.comment = comment;
        this.nodeIdList = nodeIdList;
    }
    addNodeId(id) {
        if (this.nodeIdList.indexOf(id) < 0) {
            this.nodeIdList.push(id);
            observer.triggerEvent(Events.OnAddNodeToGroup, {
                groupId: this.id,
                nodeId: id
            });
        }
    }
    removeNodeId(id) {
        let idx = this.nodeIdList.indexOf(id);
        if (idx >= 0) {
            this.nodeIdList.splice(idx, 1);
            observer.triggerEvent(Events.OnRemoveNodeFromGroup, {
                groupId: this.id,
                nodeId: id,
            });
        }
    }
    hasNodeId(id) {
        return this.nodeIdList.indexOf(id) >= 0;
    }
}
export default Group;
//# sourceMappingURL=group.js.map