import EventHandler from "./event_handler.js";
export interface HistoryEntry<T = unknown> {
    key: string;
    data: T;
}
export interface HistoryBatchEntry<T = unknown> {
    key: string;
    description: string;
    entries: HistoryEntry<T>[];
}
interface Action<T = unknown> {
    description: string;
    do(data: T, isRedo?: boolean): any;
    undo(data: T): any;
}
export declare class ActionData<T = unknown> {
    arg: T;
    data: any;
    constructor(arg: any);
    set(name: string, value: any): void;
    get(name: string): any;
    consume(name: string): any;
}
export declare const registerAction: (key: string, action: Action) => void;
export declare class HistoryManager extends EventHandler {
    entries: HistoryEntry[] | HistoryBatchEntry[];
    historyIndex: number;
    batch: HistoryEntry[];
    redo(): boolean;
    undo(): boolean;
    pushAction(name: string, data: ActionData): void;
    doAction<T>(name: string, arg?: T, callback?: (data: ActionData<T>) => void): any;
    doBatchAction<T>(key: string, arg?: T, callback?: (data: ActionData<T>) => void): any;
    finishBatch(key: string, description?: string): void;
    resetBatch(): void;
    cancelBatch(): void;
    canUndo(): boolean;
    canRedo(): boolean;
    reset(): void;
    getAction(name: string): Action<any>;
}
export {};
