import Node, { NodeType } from "./node.js";
import Patch from "./patch.js";
class Module extends Node {
    constructor() {
        super(...arguments);
        this.type = NodeType.Module;
        this.name = "New module";
        this.patch = new Patch(this);
        this.inputNodes = {};
        this.outputNodes = {};
    }
    isConnectableInputPort(key) {
        return key in this.inputNodes;
    }
    isConnectableOutputPort(key) {
        return key in this.outputNodes;
    }
    getConnectableInputPorts() {
        return Object.entries(this.inputNodes).map(([id, node]) => {
            return [id, node.name];
        });
    }
}
export default Module;
//# sourceMappingURL=module.js.map