import Connection from "./connection.js";
import Node from "./node.js";
export declare enum PortType {
    Output = 0,
    Input = 1,
    InputMulti = 2
}
declare type ConnectionEntries = [number, Connection][];
declare class Port {
    key: string;
    type: PortType;
    ownerNode: Node;
    connections: ConnectionEntries;
    constructor(key: string, type: PortType, ownerNode: Node);
    getConnectionIndex(id: number): number;
    hasConnections(): boolean;
    createConnection(id: number, oppositePort: Port, inputIndex?: number): Connection;
    removeConnection(id: number): Connection;
    getConnection(id: number): Connection;
    getName(): string;
    getComponentPort(): import("./component_manager.js").Input | import("./component_manager.js").Output;
}
export default Port;
