import { exportConnection } from "./export.js";
export const getRelatedConnections = (nodes, mode) => {
    const relatedMap = {};
    const lazyCreateEntry = (id) => {
        if (!(id in relatedMap)) {
            relatedMap[id] = {
                outputs: [],
                inputs: []
            };
        }
    };
    const idExist = (id) => {
        //let c = nodes.filter(n => n.id == id);
        let c = nodes.every(n => n.id != id);
        return (mode == "external" ? c : !c);
    };
    for (let node of Object.values(nodes)) {
        for (let port of Object.values(node.inputs)) {
            for (let [_, connection] of port.connections) {
                if (idExist(connection.outputPort.ownerNode.id)) {
                    lazyCreateEntry(node.id);
                    relatedMap[node.id].inputs.push(exportConnection(connection));
                }
            }
        }
        for (let port of Object.values(node.outputs)) {
            for (let [_, connection] of port.connections) {
                if (idExist(connection.inputPort.ownerNode.id)) {
                    lazyCreateEntry(node.id);
                    relatedMap[node.id].outputs.push(exportConnection(connection));
                }
            }
        }
    }
    return relatedMap;
};
//# sourceMappingURL=related_connections.js.map