import Project from "./project.js";
declare type Validator = (token: Token) => boolean;
declare type ValidatorMap = {
    [name: string]: {
        [idx: string]: Validator;
    };
};
declare type AutoComplete = string[] | (() => void) | null;
declare type CommandFn = (tokens: Token[], validatorId?: string) => boolean;
interface Command {
    name: string[];
    validators: ValidatorMap;
    autocomplete: AutoComplete;
    fn: CommandFn;
}
declare enum TokenType {
    String = 0,
    Object = 1,
    Array = 2,
    Number = 3,
    Keyword = 4
}
interface Token {
    text: string;
    type: TokenType;
}
export declare const commands: Command[];
export declare const getProject: () => Project;
export declare const setProject: (setProject: Project) => void;
export declare let lastErrorMessage: string;
export declare let print: (text: string) => void;
export declare const setPrintFn: (fn: (text: string) => void) => void;
export declare const fail: (msg: string) => boolean;
export declare const parseCmdLine: (cmd: string) => Token[];
export declare const registerCommand: (name: string[], validators: ValidatorMap, autocomplete: AutoComplete, fn: CommandFn) => void;
export declare const findCommand: (name: string) => Command | null;
export declare const executeCommand: (cmdLine: string) => boolean;
export {};
