import { registerNamespace } from "./../component_manager.js";

let namespace = registerNamespace("core.async", {
    name: "Core.Async",
    description: ``,
});

namespace.registerComponent("interval", {
    name: "Interval",
    inputs: {
        "milliseconds": {
            name: "Milliseconds",
            type: "number",
        },
    },
    outputs: {
        "counter": {
            name: "Counter",
            type: "number",
            signal: true,
        },
        "timer_id": {
            name: "Timer ID",
            type: "number"
        },
    },
    signalEvaluator: `
    var _c@{node_id}=0;
    @{out:timer_id} = setInterval(function () {
        @{out:counter}=_c@{node_id}++;
        @{triggerSignal:counter};
    }, @{in:milliseconds});`
});

namespace.registerComponent("timeout", {
    name: "Timeout",
    inputs: {
        "milliseconds": {
            name: "Milliseconds",
            type: "number",
        },
    },
    outputs: {
        "timeout": {
            name: "Timeout",
            type: "undefined",
            signal: true,
        },
        "timer_id": {
            name: "Timer ID",
            type: "number"
        },
    },
    signalEvaluator: `
        @{out:timer_id} = setTimeout(function () {
            @{out:timeout}=true;
            @{triggerSignal:timeout};
        }, @{in:milliseconds});`
});
