import { registerNamespace } from "./../component_manager.js";

let namespace = registerNamespace("core.iteration", {
    name: "Core.Iteration",
    description: ``
});

namespace.registerComponent("count", {
    name: "Count",
    description: "",
    inputs: {
        "start": {
            name: "Start",
            type: "number",
            required: true,
        },
        "end": {
            name: "End",
            type: "number",
            required: true,
        }
    },
    outputs: {
        "value": {
            name: "Value",
            type: "number",
            signal: true,
        },
        "finished": {
            name: "Finished",
            type: "signal",
            signal: true,
        }
    },
    //evaluator: "for (var i=${in:start};i<${in:end};i++) {${out:value}=i;triggerSignal(${signal:value}, i)};triggerSignal(${signal:finished})",
    signalEvaluator: `
        $for(@{in:start}, @{in:end}, 1,
            function (i) {
                @{out:value}=i;
                @{triggerSignal:value};
            },
            function () {
                @{out:finished}=@{in:start}-@{in:end};
                @{triggerSignal:finished};
            });
        `
});
