import { registerNamespace } from "./../component_manager.js";

let ns_core_memory = registerNamespace("core.memory", {
    name: "Memory",
    description: ``,
});

ns_core_memory.registerComponent("read", {
    name: "Read",
    inputs: {
        "memory": {
            name: "Memory",
            type: "memory",
        },
    },
    outputs: {
        "value": {
            name: "Value",
            type: "any"
        }
    },
    evaluator: `@{out:value}=@{in:memory}[0];` 
});

ns_core_memory.registerComponent("write", {
    name: "Write",
    inputs: {
        "memory": {
            name: "Memory",
            type: "memory",
            required: false,
        },
        "value": {
            name: "Value",
            type: "any",
        },
    },
    outputs: {
        "memory": {
            name: "Memory",
            type: "memory"
        }
    },
    evaluator: () => {
        let memory = undefined;

        if (memory) {
            return `@{out:memory}=@{in:memory};@{in:memory}[0]=@{in:value}`;
        } else {
            return `@{out:memory}=[@{in:value}];` 
        }
    }
});
