
export interface INormalizer {
    get: (id: number) => number;
}

export class Normalizer implements INormalizer {
    normalizedMap: {[id: number]: number} = {};
    idGenerator: IDGenerator;

    constructor(idGenerator: IDGenerator) {
        this.idGenerator = idGenerator;
    }

    get(id: number) {
        if (!(id in this.normalizedMap)) {
            return this.normalizedMap[id] = this.idGenerator.next();
        }
        return this.normalizedMap[id];
    };
}

class IDGenerator {
    id = 0;
    next() {
        return this.id++;
    }
    reset() {
        this.id = 0;
    }
}

export default IDGenerator;