import { getComponent } from "./component_manager.js";
import Node from "./node.js";

class Property {
    ownerNode: Node;
    key: string = "";
    value: any = null;
    isSet = false;

    constructor(ownerNode: Node, value?: any) {
        this.ownerNode = ownerNode;
        this.value = value;
    }

    getValue() {
        if (!this.isSet) {
            let component = getComponent(this.ownerNode.componentIdentKey);
            return component?.data.properties?.[this.key].defaultValue;
        }
        return this.value;
    }

    setValue(value: any) {
        this.value = value;
        this.isSet = true;
    }
}

export default Property;