export interface TypeProperties {
    key?: string;
    name: string;
    defaultComponent: string | null;
    validator?: (x: number) => boolean;
}

type TypeMap = {
    [key: string]: TypeProperties
}

let types: TypeMap = {};

export const getType = (typeKey: string) => {
    return types[typeKey];
}

export const registerType = (typeKey: string, props: TypeProperties) => {
    props.key = typeKey;
    types[typeKey] = props;
}

registerType("void", {
    name: "Void",
    defaultComponent: null
});

registerType("any", {
    name: "Any",
    defaultComponent: null
});

// registerType("adaptive", {
//     name: "Adaptive",
//     defaultComponent: null
// });

registerType("flow_input", {
    name: "Flow input",
    defaultComponent: null
});

registerType("flow_output", {
    name: "Flow output",
    defaultComponent: null
});