
import Project from "../dist/project.js";
import Component from "../dist/component.js";
import Observer from "../dist/observer.js";

/*
const stringifyConnections = (node) => {

    console.log("--------------------------");
    console.log("Node(" + node.id + ")");

    console.log("  Outputs:")
    for (let [portName, port] of Object.entries(node.outputs)) {
        for (let [id, conn] of Object.entries(port.connections)) {
            console.log("    " + portName + " -> Node(" + conn.inputPort.ownerNode.id + ")." + conn.inputPort.name);
        }
    }

    console.log("  Inputs:")
    for (let [portName, port] of Object.entries(node.inputs)) {
        for (let [id, conn] of Object.entries(port.connections)) {
            console.log("    " + portName + " <- Node(" + conn.outputPort.ownerNode.id + ")." + conn.outputPort.name);
        }
    }
}
*/

/*

Node(1):Output1 -> Node(2).Input1
Node(1):Output2 -> Node(2):Input1

  Outputs:
    Output1 -> Node(2):Input1
    Output2 -> Node(2):Input2

*/

/*
Observer.addEventListener("onCreateNode", (node) => {
    console.log("onCreateNode, id=" + node.id)
});

Observer.addEventListener("onRemoveNode", (node) => {
    console.log("onRemoveNode, id=" + node.id)
});

Observer.addEventListener("onCreateConnection", connection => {
    console.log("onCreateConnection, conn=" + connection.id)
});

let project = new Project();
let patch = project.createPatch(null);
let node1 = patch.createNode(new Component());
let node2 = patch.createNode(new Component());

node1.createConnection("output1", node2, "input1");
node1.createConnection("output2", node2, "input2");
node1.createConnection("output3", node2, "input3");
node1.createConnection("output2", node2, "input1");

stringifyConnections(node1);
stringifyConnections(node2);

node1.removeConnection("output3")

console.log("Removed connection")

stringifyConnections(node1);
stringifyConnections(node2);
*/



const NUM_NODES = 4;
const NUM_CONNECTIONS = 10;
const NUM_PORT_COUNT = 10;

let createdNodes = {};

let project = new Project();
let patch = project.createPatch(null);

for (let i = 0; i < NUM_NODES; i++) {
    let node = patch.createNode(new Component());
    createdNodes[node.id] = {
        node: node,
        connections: {}
    };
}

let nodesKeyValues = Object.entries(createdNodes);

for (let i = 0; i < NUM_CONNECTIONS; i++) {

    let keyValueIdxFrom = Math.floor(Math.random() * NUM_NODES);
    let keyValueIdxTo = Math.floor(Math.random() * NUM_NODES);

    if (keyValueIdxTo == keyValueIdxFrom) {
        keyValueIdxTo = (keyValueIdxTo + 1) % NUM_NODES;
    }

    //console.log(keyValueIdxFrom, keyValueIdxTo)

    let fromKVEntry = nodesKeyValues[keyValueIdxFrom][1];
    let toKVEntry = nodesKeyValues[keyValueIdxTo][1];

    let fromNode = fromKVEntry.node;
    let toNode = toKVEntry.node;
    let fromPort = "Output" + Math.floor(Math.random() * NUM_PORT_COUNT);
    let toPort = "Input" + Math.floor(Math.random() * NUM_PORT_COUNT);

    fromNode.createConnection(fromPort, toNode, toPort);
}